//JOHN PALMISANO		4-24-04

//FOR NEW CEREBELLUM ONLY



#include "jsp2Utilmobot2004.h"



//note: make totalangle a multiple of resolution or bad rounding will occur

#define resolution 30//larger number means more accurate, but also more ram used

#define totalangle 60//total angle that it turns

#define safety_angle 7//angle to avoid stuff at

#define speed 100//max speed

#define avoiddistance 165//stays further away from objects when this number is smaller



int i=0;

int avoidob=0;

int avoidob_old=resolution/2;

long int sum=0;

long int oldsum=0;

int map[resolution];

int direction=1;

int scanmod=8;



//timer interrupt kills poor servo scanner =(

/*#INT_TIMER1

TIMER1_isr()//(an overflow is 104ms exactly for div by 8)

{



}*/



void emergency()

{

	//Right:A3<170		Left:A2<150	to be activated

	if (analog(A3)<142 || analog(A2)<122)//safety bumper

		{

		if (direction==0)//scan right

			{

			i=resolution;

			scan(totalangle/2+scanmod);//turn servo to scan angle

			}

		else//direction=1 scan left

			{

			i=1;//weird things happen if this equals 0, so leave as 1!

			scan(-totalangle/2+scanmod);//turn servo to scan angle

			}

		motors(-100,-100);

		delay_ms(650);

		motors(-100,100);//turn right

		delay_ms(800);

		}

}



//sense

void scanner()//create a 2D map

{

	//scan going the other direction

	if (direction==0)

		direction=1;

	else

		direction=0;

		

	if (direction==0)//scan clockwise (right)

		{

		for (i=0; i<resolution/2; i++)

			{

			emergency();

			scan(i*(totalangle/(resolution/2))-totalangle/2+scanmod);//turn servo to scan angle

			map[i]=analog(A1);// read scan value on middle

			map[i+(resolution/2)]=analog(A5);//read scan value on left side

			if (i<4)//added extra delay for momentum change

				delay_ms(6-i);

			delay_ms(15+oldsum/60);//servo reaction speed, slows down when closer to objects

			}

		}

	else//direction=1 scan counterclockwise (left)

		{

		for (i=resolution/2; i>0; i--)

			{

			emergency();

			scan((i-1)*(totalangle/(resolution/2))-totalangle/2+scanmod);//turn servo to scan angle

			map[i-1]=analog(A1);// read scan value on right side

			map[i-1+(resolution/2)]=analog(A5);//

			if (i>=resolution-4)//added extra delay for momentum change

				delay_ms(6-(resolution-i));

			delay_ms(15+oldsum/60);//servo reaction speed, slows down when closer to objects

			}

		}

		

	//print out scanned maps

	/*i=0;

	while(i<resolution)

		{

		printf("%u ", map[i]);

		i++;

		}

	printf("\r\n");*/

}



//plan

void interpretmap()//find masses of objects, cleans out noise too!

{

	avoidob=0;

	oldsum=0;//stores highest value

	

	for (i=0; i<(resolution-4); i++)

		{

		sum=map[i]+map[i+1]+map[i+2]+map[i+3]+map[i+4];

		if (sum>oldsum)

			{

			avoidob=i+2;

			oldsum=sum;

			}

		}

	avoidob_old=(avoidob+avoidob_old)/2;//find average of last 2 sweeps

	//printf("%u\r\n", avoidob_old);//print out where object is detected

}



//act

void pathplan()//find path to take

{

	if (oldsum>avoiddistance)//collision case, rotate out of the way

		{

		if (avoidob_old>(resolution/2-safety_angle) && avoidob_old<(resolution/2))//turn right

			{

			//printf("turning right\r\n");

			motors(100,-100);

			delay_ms(350);

			}

		else if (avoidob_old<(resolution/2+safety_angle) && avoidob_old>=(resolution/2))//turn left

			{

			//printf("turning left\r\n");

			motors(-100,100);

			delay_ms(350);

			}

		else// if (avoidob_old>=(resolution/2+safety_angle) || avoidob_old<=(resolution/2-safety_angle))//going straight because object on the side

			{

			//printf("going straight slow\r\n");

			motors(80,80);

			}

		}

	else//does not see anything in the way so go straight/make small adjustments

		{

		if (avoidob_old>(resolution/2-safety_angle) && avoidob_old<(resolution/2))//veer right

			{

			//printf("veering right\r\n");

			motors(100,100-oldsum/6);

			}

		else if (avoidob_old<(resolution/2+safety_angle) && avoidob_old>=(resolution/2))//veer left

			{

			//printf("veering left\r\n");

			motors(100-oldsum/6,100);

			}

		else// if (avoidob_old>=(resolution/2+safety_angle) || avoidob_old<=(resolution/2-safety_angle))//going straight

			{

			//printf("going straight fast\r\n");

			motors(100,100);

			}

		}

}



void main()

{

	//interrupts - read IR after every overflow

	//setup_timer_1(T1_INTERNAL|T1_DIV_BY_8);

	//setup_timer_2(T2_DIV_BY_4,255,16);//the interrupt occurs 400 times a second, use page 123 for help

	//enable_interrupts(INT_TIMER1);//overflow at 104ms

	//enable_interrupts(global);

	   

    //initialization

    cereb_init();

    scan(-totalangle/2+scanmod);

    delay_ms(1000);



	while(1)//code below here only

		{

		scanner();//sense

		interpretmap();//plan

		pathplan();//act

		//printf("A2: %u A3: %u\r\n", analog(A2), analog(A3));

		}

    while(1);

}